//+------------------------------------------------------------------+ 
//|                _TRO_PLOT_C                                       | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

#property indicator_buffers 1 
#property indicator_color1 Blue

extern string Parms     = "Moving Averages;5;0;1;0;0";
extern int    myBars    = 100 ;


int      window;  
int      totalParms;

string   aParms[];

int      corner  ;
string   shortName ,labelNames ;

double cVal = 0, pVal = 0;
int xPeriod ;
//---- indicator buffers

double ExtMapBuffer0[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
      if (StringSubstr(Parms,StringLen(Parms),1) != ";")
      Parms = StringConcatenate(Parms,";");
      
         int  s      = 0;
         int  i      = StringFind(Parms,";",s);
         int time;
         string current;     
         string temp;
         
            while (i > 0)
            {
               current = StringSubstr(Parms,s,i-s);
               ArrayResize(aParms,ArraySize(aParms)+1);
               aParms[ArraySize(aParms)-1] = current; 
               s = i + 1;
               i = StringFind(Parms,";",s);                                                                                                             
            }

totalParms = ArraySize(aParms) ;
    
    
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexLabel(0, aParms[0]);    


   corner     = 0;

   
string cTitle = aParms[0] ;

if(totalParms >= 4) { cTitle = cTitle + "," + aParms[1] ; }
if(totalParms >= 5) { cTitle = cTitle + "," + aParms[2] ; }
if(totalParms >= 6) { cTitle = cTitle + "," + aParms[3] ; }
if(totalParms >= 7) { cTitle = cTitle + "," + aParms[4] ; }
if(totalParms >= 8) { cTitle = cTitle + "," + aParms[5] ; }
if(totalParms >= 9) { cTitle = cTitle + "," + aParms[6] ; }
if(totalParms >= 10) { cTitle = cTitle + "," + aParms[7] ; }
if(totalParms >= 11) { cTitle = cTitle + "," + aParms[8] ; }
if(totalParms >= 12) { cTitle = cTitle + "," + aParms[9] ; }
if(totalParms >= 13) { cTitle = cTitle + "," + aParms[10] ; }
if(totalParms >= 14) { cTitle = cTitle + "," + aParms[11] ; }

   shortName  = MakeUniqueName(cTitle+" "," ");
   labelNames = shortName;
   IndicatorShortName(shortName); 
    
    
return(0);
   
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   
   return(0);
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{


int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;

   if(myBars > 0 ) { limit = myBars ; } else { limit = Bars - counted_bars; }

   for(int i=limit; i>=0; i--)
   {
    DoWork( Symbol() , Period() , i ) ;
    
    ExtMapBuffer0[i] = cVal;   
   }    
     
     
return(0);
}

//+------------------------------------------------------------------+

void DoWork( string myPair, int myPeriod, int myShift  )  
{

int iParm = totalParms - 3 ;

while(true)
{
if(iParm==1 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],myShift); break ; }
if(iParm==2 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],myShift); break ; }
if(iParm==3 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],myShift); break ; }
if(iParm==4 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],myShift); break ; }
if(iParm==5 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],myShift); break ; }
if(iParm==6 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],aParms[7],myShift); break ; }
if(iParm==7 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],aParms[7],aParms[8],myShift); break ; }
if(iParm==8 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],aParms[7],aParms[8],aParms[9],myShift); break ; }
if(iParm==9 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],aParms[7],aParms[8],aParms[9],aParms[10],myShift); break ; }
if(iParm==10 ) {cVal = iCustom(myPair,myPeriod,aParms[0],aParms[1],aParms[2],aParms[3],aParms[4],aParms[5],aParms[6],aParms[7],aParms[8],aParms[9],aParms[10],aParms[11],myShift); break ; }
         
               
break ;  }
                                        
}



//+------------------------------------------------------------------+
string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}